<?php

ini_set("session.gc_maxlifetime","4230");
ini_set("session.save_path", "./tmp");
ini_set("allow_call_time_pass_reference", "on");

session_start();


// registering posted and get'ed variables.
if(!empty($_GET)) extract($_GET);
if(!empty($_POST)) extract($_POST);



// timeout must be long for step 8
if ($HTTP_POST_VARS["action"] == "step8") {
	set_time_limit(0);
} else {
	set_time_limit(600);
}

// ************************** Page Level Param's *********************************


	include "./includes/cache.php";
	include "./lib/xml.php";  // must be included before functions.php.
	include "functions.php";
	include "./lib/lastRSS.php";


	include "./settings/secureSettings.xml.php"; // must be included before config.inc.php.
	include "./settings/config.inc.php";
	include "./settings/messages.php";
	include "./lib/ftp.php";

//echo $extraHtmlCode) . "\n\n\n";
//echo stripslashes(addslashes($HTTP_POST_VARS[extraHtmlCode])) . "\n\n\n";
	// Assign posted var's to regular vars.
	/*
	while (list($n,$v) = each($HTTP_GET_VARS)) { $$n = $v; }
	while (list($n,$v) = each($HTTP_POST_VARS)) { $$n = $v; }
	*/

	//while (list($n,$v) = each($HTTP_POST_VARS)) { echo "<b>Var Name: " . $n . "</b>" . ":" . $v . "<br>\n"; }



	// array of messages to be displayed.
	$displayMsgs = array();

	// if we're not logged in or coming from a page.
	if(!$_SESSION["sess_login"]) {

		$action = "authentication"; // default action.
		$following_action = "step0"; // default action.

	} else if ($_SESSION["sess_login"]  && !$HTTP_GET_VARS["action"] & !$HTTP_POST_VARS["action"]) {

		// used in case coming from a page not part of the app but still logged in.
		$action = "step0"; 
		$following_action = "step1"; 
		
	} else if ($HTTP_POST_VARS["action"]) {

		$prev_action = $HTTP_POST_VARS["action"];
		$action = $HTTP_POST_VARS["following_action"];

	} else if ($HTTP_GET_VARS["action"]) {

		$prev_action = $HTTP_GET_VARS["prev_action"];
		$action = $HTTP_GET_VARS["action"];
		$following_action = $HTTP_GET_VARS["following_action"];

	}

	// add this step to the list of steps completed / visited.
	if (!strpos($_SESSION["steps_visited"], "," . $action)) {
			$_SESSION["steps_visited"] .= "," . $action;
	}

// ******************************************************************************




?>
<html>
<head>

	<? include "includes/head.php"; ?>

</head>

<body onLoad="clearPreloadPage();"> 

<!-- "loading alert" -->
<div id="prepage" class="loadingAlert" align="center">

	<table border="0" width="300" align="center" bgcolor="">
		<tr>
			<td><img src="images/spacer.gif" height="30" width="0"></td>
		</tr>
		<tr>
			<td class="loadingAlert" ALIGN="CENTER">
				Currently loading please wait...
			</td>
		</tr>
	</table>

	<!-- Used to load pop-up boxes for upload keywords, file upload etc. -->
	<div id="tek" class="helpbox">
	<div id="hbtitle" class="tit"></div>
	<div style="padding: 5px; text-align: left;" id="texthelp"></div>
	</div>

</div>
<!-- end "loading alert" -->


<?
	// Used to load the progress bar if we're going to the step to produce the pages but not if we're just saving a session.
	if ($HTTP_POST_VARS["following_action"] == "step8" && !$HTTP_POST_VARS["sessionName"]) {
		include("includes/progressBar.php");
	}
?>


<table cellpadding=0 cellspacing=0 style="border:solid 1px black;" width="772" align="center" bgcolor=white border=0 bordercolor=green bgcolor="">
	<tr>
		<td>


<?

include("includes/topMenu.php");

?>

		</td>
	</tr>
	<tr>
		<td>

<?

include("includes/progressBarTop.php");

?>

		</td>
	</tr>
	<tr>
		<td height=500 valign=top>



<?

	flush();
	ob_flush();

?>




<?

	/************************************************************************
	 * This section pertains to functional actions we must do based upon the 
	 * previous page but done before displaying the page.
	 ************************************************************************/

	// If the user hit the "cancel" button refresh everything and go back.
	if($HTTP_POST_VARS["pageFunction"] == "cancel") {

		$prev_action = "step0";
		$action = "step1";
		$following_action = "step2";
		$_SESSION["session_progress"] = 0; // used for the progress bar and similar displays.

	// IMPORT KEYWORDS FROM A KEYWORD FILE
	} elseif ($HTTP_POST_VARS["pageFunction"] == "upload") {

		$specKeywords = parseKeywordsCSV($_FILES['keyfile']['tmp_name']);

		// Check if any keywords were actually retrieved at all.
		if (!$specKeywords) {
			$displayMsgs[count($displayMsgs)+1] = $messages['noKeywordsFoundInUploadCSV'];
		}

		$prev_action = "step0";
		$action = "step1";
		$following_action = "step2";
		$_SESSION["session_progress"] = 100;


	// PULLING FROM THE EXTERNAL KEYWORDS SOURCE.
	} elseif ($HTTP_POST_VARS["pageFunction"] == "getRelatedKeywords") {

		$arrKeywords = getRelatedKeywords($basekeyword, 500);

		$prev_action = "step0";
		$action = "step1";
		$following_action = "step2";
		$_SESSION["session_progress"] = 100;


		// Choosing the information to display based upon the result.
		switch ($arrKeywords[0]) {
			
			case 0:

				$displayMsgs[count($displayMsgs)+1] = $messages['noKeywordsFound'];
 				break;

			case 1:

				for ($i=0; $i<count($arrKeywords[1]) ;$i++) {			
					$specKeywords .= trim($arrKeywords[1][$i]) . "||||";
				}

				$displayMsgs[count($displayMsgs)+1] = $messages['lessThanTheRequestedMaximumOfKeywordsWereFound'];
				$specKeywords = substr($specKeywords, 0, strlen($specKeywords)-4);

				break;

			case 2:

				for ($i=0; $i<count($arrKeywords[1]) ;$i++) {			
					$specKeywords .= $arrKeywords[1][$i] . "||||";
				}
				$displayMsgs[count($displayMsgs)+1] = $messages['moreThanTheRequestedMaximumOfKeywordsWereFound'];
				$specKeywords = substr($specKeywords, 0, strlen($specKeywords)-4);

				break;
				
			case 3:

				$displayMsgs[count($displayMsgs)+1] = $messages['serverErrorPullingKeywords'];
				break;
		}



	// CHANGE ADMIN PASSWORD
	} elseif ($HTTP_POST_VARS[pageFunction] == "changePassword") {

		$displayMsgs[count($displayMsgs)+1] = changePassword($newpass);
		$prev_action = "step0";
		$action = "step1";
		$following_action = "step2";
		$_SESSION["session_progress"] = 100;


	} elseif ($HTTP_POST_VARS[pageFunction] == "ftpInfo") {

		$displayMsgs[count($displayMsgs)+1] = changeFtpInfo($ftpUsername, $ftpPassword, $ftpServer, $ftpWebRoot);
		$prev_action = "step0";
		$action = "step1";
		$following_action = "step2";
		$_SESSION["session_progress"] = 100;

	// if this session was selected for save.
	} elseif ($HTTP_POST_VARS["sessionName"]) {
			
		if (!saveSession($_SESSION["session_current_settings"], $_SESSION["session_name"], $HTTP_POST_VARS["sessionName"])) {
			$displayMsgs[count($displayMsgs)+1] = $messages['loadSessionFailure'];					
		}	

		$prev_action = "step6";
		$action = "step7";
		$following_action = "step8";
	}



	/*************** Loading a session's settings. ************* 
	 * Check if the click was for loading of old session settings
	 ***********************************************************/
	if (session_is_registered("sess_login")) {


		if ($load_settings) {

			$prev_action = "step0";
			$action = "step1";
			$following_action = "step2";

			$_SESSION["session_name"] = $HTTP_POST_VARS[session_name];
			$_SESSION["session_current_settings"] = loadSession($HTTP_POST_VARS[session_name], $action, true);

		// Load the default one.
		} elseif (!$_SESSION["session_current_settings"]) {

			session_register("session_current_settings");
			session_register("session_name");
			
			$_SESSION["session_name"] = "default";
			$_SESSION["session_current_settings"] = loadSession("default", $action);

		// if we're not loading the settings we need to save them to this session's array.
		} else {

			// save settings to sessions array for this step, in case any data has changed. This does not save to the XML file but keeps the same formatting.
			$_SESSION["session_current_settings"] = preserveSessionSettings($prev_action, $_SESSION["session_name"], $_SESSION["session_current_settings"]);

			//$_SESSION["session_current_settings"] = preserveSessionSettings($action, $_SESSION["session_name"], $_SESSION["session_current_settings"], false);
			//$_SESSION["session_current_settings"] = preserveSessionSettings($following_action, $_SESSION["session_name"], $_SESSION["session_current_settings"]);
			
		}


	}


	// Assign session based keywords list to current list of keywords as processed previously.
	if ($specKeywords) {
		$_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"] = $specKeywords;
	}

	// *********************************************************


	/************************************************************************
	 * This section pertains to displaying the data itself.
	 ************************************************************************/

	// Pull the help info for this step.
	$arrHelp = @getXmlHelp($action);
	
	// If you're not logged in.
	if (!session_is_registered("sess_login")) {
		
		include "includes/authenticate.php";

	} elseif ($action == "step0") {

		// This is the first page.
		include "includes/step0.php";
		$prev_action = "";
		$following_action = "step1";
		

	} elseif ($action == "step1") {

		// This is the first page.
		include "includes/step1.php";
		$prev_action = "step0";
		$following_action = "step2";

	} if ($action == "step2") {

		include "includes/step2.php";
		$prev_action = "step1";
		$following_action = "step4";
		// create the formatted keywords list from before and remove the carriage returns, replace with correct marker.
		$_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"] = $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"];
		/*
		// in case we have additional spaces
		$_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"] = str_replace("~~ ", "~~", $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"]);
		// in case we have additional spaces
		$_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"] = str_replace(" ~~", "~~", $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"]);
		// I do this for windows machines, the PHP will have a \n\r instead of just a \n on other systems.
		$_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"] = str_replace("\r", "", $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step1"]["keywords"]);
		*/

		
	}
	elseif ($action == "step4") {
		
		include "includes/step4.php";
		$prev_action = 'step2';
		$following_action = "step5";

	}
	elseif ($action == "step5") {
		
		include "includes/step5.php";
		$prev_action = 'step4';
		$following_action = "step3";

	}
	elseif ($action == "step3") {
		
		include "includes/step3.php";
		$prev_action = 'step5';	
		$following_action = "step6";

	}
	elseif ($action == "step6") {
		
		include "includes/step6.php";
		$prev_action = 'step3';
		$following_action = "step7";

	}
	elseif ($action == "step7" ) {

		include "includes/step7.php";
		$prev_action = 'step6';
		$following_action = "step8";

	}
	elseif ($action == "step8") {

		// set the last session to be the default.
		if (!saveSession($_SESSION["session_current_settings"], $_SESSION["session_name"], "default" )){};

		createKeywordPages($_SESSION["session_current_settings"][$_SESSION["session_name"]], stripSlashesConditional($HTTP_POST_VARS[keywordsPageContent]));
		createIndexPages($_SESSION["session_current_settings"][$_SESSION["session_name"]], stripSlashesConditional($HTTP_POST_VARS[indexPageContent]));

		// if we're supposed to create a zip file as well.
		/*
		if ($_SESSION["session_current_settings"][$_SESSION["session_name"]]["step7"]["saveType"] == "zipFile") {
			createZipFile("../" . $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step2"]["baseDir"], $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step3"]["baseDir"] . ".zip");

			if (is_file("./zipFiles/" . $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step3"]["baseDir"] . ".zip")) {
				$displayMsgs[count($displayMsgs)+1] = $messages['yourZipFileHasBeenCreated'];
			} else {
				$displayMsgs[count($displayMsgs)+1] = $messages['yourZipFileHasNotBeenCreated'];
			}

		}
		*/



		// save the dir as a related dir for later listing.
		if (!saveRelatedDir($_SESSION["session_current_settings"][$_SESSION["session_name"]]["step3"]["baseDir"], $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step3"]["indexFilename"], $_SESSION["session_current_settings"][$_SESSION["session_name"]]["step3"]["baseDirText"]) ){};
		
		

		include "includes/step8.php";
		$prev_action = 'step7';
		$following_action = "";

	}



?>



					</td>
				</tr>
				<TR>
					<TD valign=bottom>
					<?
						// Should be at the bottom of every page.
						include("includes/footer.php");
					?>
					</TD>
				</TR>
			</table>

					

			

		</TD>
	</TR>
</table>
	<!-- end parent table for the whole page -->


<!-- utility form for previous submit button. -->
<form name="frmPrevious" action="<? echo $GLOBALS["PHP_SELF"]; ?>" method="post">		
	<input type="hidden" name="action" value="<? echo $prev_action ?>">
	<input type="hidden" name="pageFunction" value="">
</form>

